// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

// "%code top" blocks.
#line 1 "parser.y"

    #include "TestLexer.h"

#line 43 "parser.cpp"




#include "yyTestParser.h"


// Unqualified %code blocks.
#line 17 "parser.y"

    #define yylex(L, S) ((S)->yylex(L))

    #define vt100GREEN "\x1b[32m"
    #define DEBUG(X) std::cout << vt100GREEN << " " << #X << std::endl

#line 59 "parser.cpp"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif



// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 132 "parser.cpp"

  /// Build a parser object.
   TestParser :: TestParser  (TestLexer* scanner_yyarg, Statement** result_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      scanner (scanner_yyarg),
      result (result_yyarg)
  {}

   TestParser ::~ TestParser  ()
  {}

   TestParser ::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
   TestParser ::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value (that.value)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
   TestParser ::basic_symbol<Base>::basic_symbol (typename Base::kind_type t)
    : Base (t)
    , value ()
  {}

  template <typename Base>
   TestParser ::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, YY_RVREF (value_type) v)
    : Base (t)
    , value (YY_MOVE (v))
  {}


  template <typename Base>
   TestParser ::symbol_kind_type
   TestParser ::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
   TestParser ::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
   TestParser ::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    value = YY_MOVE (s.value);
  }

  // by_kind.
   TestParser ::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
   TestParser ::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

   TestParser ::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

   TestParser ::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
   TestParser ::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
   TestParser ::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

   TestParser ::symbol_kind_type
   TestParser ::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


   TestParser ::symbol_kind_type
   TestParser ::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
   TestParser ::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

   TestParser ::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
   TestParser ::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
   TestParser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

   TestParser ::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

   TestParser ::symbol_kind_type
   TestParser ::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

   TestParser ::stack_symbol_type::stack_symbol_type ()
  {}

   TestParser ::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.value))
  {
#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

   TestParser ::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.value))
  {
    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
   TestParser ::stack_symbol_type&
   TestParser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    return *this;
  }

   TestParser ::stack_symbol_type&
   TestParser ::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
   TestParser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YY_USE (yysym.kind ());
  }

#if YYDEBUG
  template <typename Base>
  void
   TestParser ::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " (";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
   TestParser ::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
   TestParser ::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
   TestParser ::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   TestParser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   TestParser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   TestParser ::debug_level_type
   TestParser ::debug_level () const
  {
    return yydebug_;
  }

  void
   TestParser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

   TestParser ::state_type
   TestParser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
   TestParser ::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
   TestParser ::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
   TestParser ::operator() ()
  {
    return parse ();
  }

  int
   TestParser ::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, scanner));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;


      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // S: statements $end
#line 74 "parser.y"
    {
        DEBUG(S : statements YYEOF);
        *result = new Block((yystack_[1].value.statements));
    }
#line 593 "parser.cpp"
    break;

  case 3: // statements: %empty
#line 82 "parser.y"
    {
        DEBUG( statements: %empty );
        (yylhs.value.statements) = new std::vector<Statement*>();
    }
#line 602 "parser.cpp"
    break;

  case 4: // statements: statements statement
#line 87 "parser.y"
    {
        DEBUG( statements: statements statement);
        (yystack_[1].value.statements)->push_back((yystack_[0].value.statement));
        (yylhs.value.statements) = (yystack_[1].value.statements);
    }
#line 612 "parser.cpp"
    break;

  case 5: // statement: OPENBRACE statements CLOSEBRACE
#line 96 "parser.y"
    {
        DEBUG( statement: OPENBRACE statements CLOSEBRACE );
        (yylhs.value.statement) = new Block((yystack_[1].value.statements));
    }
#line 621 "parser.cpp"
    break;

  case 6: // statement: type IDENTIFIER ASSIGN rvalue SEMICOLON
#line 101 "parser.y"
    {
        DEBUG( statement: type lvalue ASSIGN rvalue SEMICOLON );
        (yylhs.value.statement) = new VarDeclaration((yystack_[4].value.type), (yystack_[3].value.str), (yystack_[1].value.rvalue));
    }
#line 630 "parser.cpp"
    break;

  case 7: // statement: lvalue ASSIGN rvalue SEMICOLON
#line 106 "parser.y"
    {
        DEBUG( statement: lvalue ASSIGN rvalue SEMICOLON );
        (yylhs.value.statement) = new Assignment((yystack_[3].value.lvalue), (yystack_[1].value.rvalue));
    }
#line 639 "parser.cpp"
    break;

  case 8: // statement: OUTPUT rvalue SEMICOLON
#line 111 "parser.y"
    {
        DEBUG( statement: OUTPUT rvalue SEMICOLON );
        (yylhs.value.statement) = new Output((yystack_[1].value.rvalue));
    }
#line 648 "parser.cpp"
    break;

  case 9: // statement: INPUT lvalue SEMICOLON
#line 116 "parser.y"
    {
        DEBUG( statement: INPUT lvalue SEMICOLON );
        (yylhs.value.statement) = new Input((yystack_[1].value.lvalue));
    }
#line 657 "parser.cpp"
    break;

  case 10: // statement: IF OPENPAREN boolexp CLOSEPAREN statement ELSE statement
#line 121 "parser.y"
    {
        DEBUG( statement: IF OPENPAREN boolexp CLOSEPAREN statement ELSE statement );
        (yylhs.value.statement) = new IfThenElse((yystack_[4].value.boolexp), (yystack_[2].value.statement), (yystack_[0].value.statement));
    }
#line 666 "parser.cpp"
    break;

  case 11: // statement: WHILE OPENPAREN boolexp CLOSEPAREN statement
#line 126 "parser.y"
    {
        DEBUG( statement: WHILE OPENPAREN boolexp CLOSEPAREN statement );
        (yylhs.value.statement) = new WhileLoop((yystack_[2].value.boolexp), (yystack_[0].value.statement));
    }
#line 675 "parser.cpp"
    break;

  case 12: // type: INT
#line 134 "parser.y"
    {
        DEBUG( type: INT );
        (yylhs.value.type) = new TypeInt32();
    }
#line 684 "parser.cpp"
    break;

  case 13: // rvalue: arithexp
#line 142 "parser.y"
    {
        DEBUG( rvalue: arithexp );
        (yylhs.value.rvalue) = (yystack_[0].value.arithexp);
    }
#line 693 "parser.cpp"
    break;

  case 14: // lvalue: IDENTIFIER
#line 150 "parser.y"
    {
        DEBUG( lvalue: IDENTIFIER );
        (yylhs.value.lvalue) = new LValueIdentifier((yystack_[0].value.str));
    }
#line 702 "parser.cpp"
    break;

  case 15: // boolexp: OPENPAREN boolexp CLOSEPAREN
#line 158 "parser.y"
    {
        DEBUG( boolexp: OPENPAREN boolexp CLOSEPAREN );
        (yylhs.value.boolexp) = (yystack_[1].value.boolexp);
    }
#line 711 "parser.cpp"
    break;

  case 16: // boolexp: relexp
#line 163 "parser.y"
    {
        DEBUG( boolexp: relexp );
        (yylhs.value.boolexp) = (yystack_[0].value.relexp);
    }
#line 720 "parser.cpp"
    break;

  case 17: // boolexp: NOT boolexp
#line 168 "parser.y"
    {
        DEBUG( boolexp: NOT boolexp );
        (yylhs.value.boolexp) = new BooleanExpressionNot((yystack_[0].value.boolexp));
    }
#line 729 "parser.cpp"
    break;

  case 18: // boolexp: boolexp AND boolexp
#line 173 "parser.y"
    {
        DEBUG( boolexp: boolexp AND boolexp );
        (yylhs.value.boolexp) = new BooleanExpressionAnd((yystack_[2].value.boolexp), (yystack_[0].value.boolexp));
    }
#line 738 "parser.cpp"
    break;

  case 19: // boolexp: boolexp OR boolexp
#line 178 "parser.y"
    {
        DEBUG( boolexp: boolexp OR boolexp );
        (yylhs.value.boolexp) = new BooleanExpressionOr((yystack_[2].value.boolexp), (yystack_[0].value.boolexp));
    }
#line 747 "parser.cpp"
    break;

  case 20: // relexp: arithexp LESS arithexp
#line 186 "parser.y"
    {
        DEBUG( relexp: arithexp LESS arithexp );
        (yylhs.value.relexp) = new RelationExpressionLess((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 756 "parser.cpp"
    break;

  case 21: // relexp: arithexp LESSEQUAL arithexp
#line 191 "parser.y"
    {
        DEBUG( relexp: arithexp LESSEQUAL arithexp );
        (yylhs.value.relexp) = new RelationExpressionLessEqual((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 765 "parser.cpp"
    break;

  case 22: // relexp: arithexp EQUAL arithexp
#line 196 "parser.y"
    {
        DEBUG( relexp: arithexp EQUAL arithexp );
        (yylhs.value.relexp) = new RelationExpressionEqual((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 774 "parser.cpp"
    break;

  case 23: // relexp: arithexp UNEQUAL arithexp
#line 201 "parser.y"
    {
        DEBUG( relexp: arithexp UNEQUAL arithexp );
        (yylhs.value.relexp) = new RelationExpressionUnequal((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 783 "parser.cpp"
    break;

  case 24: // relexp: arithexp GREATEREQUAL arithexp
#line 206 "parser.y"
    {
        DEBUG( relexp: arithexp GREATEREQUAL arithexp );
        (yylhs.value.relexp) = new RelationExpressionGreaterEqual((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 792 "parser.cpp"
    break;

  case 25: // relexp: arithexp GREATER arithexp
#line 211 "parser.y"
    {
        DEBUG( relexp: arithexp GREATER arithexp );
        (yylhs.value.relexp) = new RelationExpressionGreater((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 801 "parser.cpp"
    break;

  case 26: // arithexp: OPENPAREN arithexp CLOSEPAREN
#line 219 "parser.y"
    {
        DEBUG( arithexp: OPENPAREN arithexp CLOSEPAREN );
        (yylhs.value.arithexp) = (yystack_[1].value.arithexp);
    }
#line 810 "parser.cpp"
    break;

  case 27: // arithexp: NUMBER
#line 224 "parser.y"
    {
        DEBUG( arithexp: NUMBER );
        (yylhs.value.arithexp) = new ArithmeticExpressionConstant((yystack_[0].value.num));
    }
#line 819 "parser.cpp"
    break;

  case 28: // arithexp: lvalue
#line 229 "parser.y"
    {
        DEBUG( arithexp: lvalue );
        (yylhs.value.arithexp) = (yystack_[0].value.lvalue);
    }
#line 828 "parser.cpp"
    break;

  case 29: // arithexp: arithexp PLUS arithexp
#line 234 "parser.y"
    {
        DEBUG( arithexp: arithexp PLUS arithexp );
        (yylhs.value.arithexp) = new ArithmeticExpressionPlus((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 837 "parser.cpp"
    break;

  case 30: // arithexp: arithexp MINUS arithexp
#line 239 "parser.y"
    {
        DEBUG( arithexp: arithexp MINUS arithexp );
        (yylhs.value.arithexp) = new ArithmeticExpressionMinus((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 846 "parser.cpp"
    break;

  case 31: // arithexp: arithexp MULT arithexp
#line 244 "parser.y"
    {
        DEBUG( arithexp: arithexp MULT arithexp );
        (yylhs.value.arithexp) = new ArithmeticExpressionMultiply((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 855 "parser.cpp"
    break;

  case 32: // arithexp: arithexp DIV arithexp
#line 249 "parser.y"
    {
        DEBUG( arithexp: arithexp DIV arithexp );
        (yylhs.value.arithexp) = new ArithmeticExpressionDivide((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 864 "parser.cpp"
    break;

  case 33: // arithexp: arithexp MOD arithexp
#line 254 "parser.y"
    {
        DEBUG( arithexp: arithexp MOD arithexp );
        (yylhs.value.arithexp) = new ArithmeticExpressionModulus((yystack_[2].value.arithexp), (yystack_[0].value.arithexp));
    }
#line 873 "parser.cpp"
    break;


#line 877 "parser.cpp"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (YY_MOVE (msg));
      }


    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;


      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
   TestParser ::error (const syntax_error& yyexc)
  {
    error (yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
   TestParser ::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0









  const signed char  TestParser ::yypact_ninf_ = -43;

  const signed char  TestParser ::yytable_ninf_ = -1;

  const signed char
   TestParser ::yypact_[] =
  {
     -43,     3,    86,   -43,   -43,   -43,   -43,    -8,    -7,     4,
      12,   -43,   -43,    18,    -9,    11,    11,    13,   -43,    12,
      21,   -43,    34,    95,     9,    12,    11,    11,    -6,   -43,
      92,     5,   -43,   117,   -43,    12,    12,    12,    12,    12,
     -43,    12,    25,     8,    55,   -43,   118,    11,    11,    12,
      12,    12,    12,    12,    12,   118,   -43,    43,    43,   -43,
     -43,   -43,    32,   -43,   -43,    59,    -3,   -43,    34,    34,
      34,    34,    34,    34,   -43,   -43,   118,   -43
  };

  const signed char
   TestParser ::yydefact_[] =
  {
       3,     0,     0,     1,     2,    14,    12,     0,     0,     0,
       0,     3,     4,     0,     0,     0,     0,     0,    27,     0,
       0,    28,    13,     0,     0,     0,     0,     0,     0,    16,
       0,     0,     9,     0,     8,     0,     0,     0,     0,     0,
       5,     0,     0,     0,     0,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,    29,    30,    31,
      32,    33,     0,     7,    15,     0,    19,    18,    20,    21,
      22,    23,    24,    25,    11,     6,     0,    10
  };

  const signed char
   TestParser ::yypgoto_[] =
  {
     -43,   -43,    41,   -42,   -43,   -23,    -2,   -15,   -43,    10
  };

  const signed char
   TestParser ::yydefgoto_[] =
  {
       0,     1,     2,    12,    13,    20,    21,    28,    29,    30
  };

  const signed char
   TestParser ::yytable_[] =
  {
      14,    31,    42,     3,    65,    15,    16,    17,    46,     5,
      25,    43,    45,    74,    18,    18,     5,     5,    62,    55,
      22,    14,    64,    24,    26,    19,    47,    48,    41,    33,
      48,    32,    66,    67,    77,    22,    44,    47,    48,    34,
      47,    48,    27,    63,    14,    57,    58,    59,    60,    61,
      75,    22,    23,    14,    35,    36,    37,    38,    39,    68,
      69,    70,    71,    72,    73,    37,    38,    39,    76,    56,
       0,     0,     0,     0,    14,    35,    36,    37,    38,    39,
      49,    50,    51,    52,    53,    54,     4,     0,     0,     0,
       0,     5,     0,     6,     7,     0,     8,     9,    10,     0,
       5,    11,     6,     7,     0,     8,     9,    10,     0,     0,
      11,    40,    35,    36,    37,    38,    39,    49,    50,    51,
      52,    53,    54,     5,     0,     6,     7,     0,     8,     9,
      10,    56,     0,    11,     0,     0,     0,    35,    36,    37,
      38,    39
  };

  const signed char
   TestParser ::yycheck_[] =
  {
       2,    16,    25,     0,    46,    13,    13,     9,    14,     5,
      19,    26,    27,    55,     3,     3,     5,     5,    41,    14,
      10,    23,    14,     5,    13,    13,    32,    33,    19,    19,
      33,    18,    47,    48,    76,    25,    26,    32,    33,    18,
      32,    33,    31,    18,    46,    35,    36,    37,    38,    39,
      18,    41,    11,    55,    20,    21,    22,    23,    24,    49,
      50,    51,    52,    53,    54,    22,    23,    24,     9,    14,
      -1,    -1,    -1,    -1,    76,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,     0,    -1,    -1,    -1,
      -1,     5,    -1,     7,     8,    -1,    10,    11,    12,    -1,
       5,    15,     7,     8,    -1,    10,    11,    12,    -1,    -1,
      15,    16,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,     5,    -1,     7,     8,    -1,    10,    11,
      12,    14,    -1,    15,    -1,    -1,    -1,    20,    21,    22,
      23,    24
  };

  const signed char
   TestParser ::yystos_[] =
  {
       0,    35,    36,     0,     0,     5,     7,     8,    10,    11,
      12,    15,    37,    38,    40,    13,    13,    40,     3,    13,
      39,    40,    43,    36,     5,    19,    13,    31,    41,    42,
      43,    41,    18,    43,    18,    20,    21,    22,    23,    24,
      16,    19,    39,    41,    43,    41,    14,    32,    33,    25,
      26,    27,    28,    29,    30,    14,    14,    43,    43,    43,
      43,    43,    39,    18,    14,    37,    41,    41,    43,    43,
      43,    43,    43,    43,    37,    18,     9,    37
  };

  const signed char
   TestParser ::yyr1_[] =
  {
       0,    34,    35,    36,    36,    37,    37,    37,    37,    37,
      37,    37,    38,    39,    40,    41,    41,    41,    41,    41,
      42,    42,    42,    42,    42,    42,    43,    43,    43,    43,
      43,    43,    43,    43
  };

  const signed char
   TestParser ::yyr2_[] =
  {
       0,     2,     2,     0,     2,     3,     5,     4,     3,     3,
       7,     5,     1,     1,     1,     3,     1,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const  TestParser ::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "NUMBER", "STRING",
  "IDENTIFIER", "COMMENT", "INT", "IF", "ELSE", "WHILE", "INPUT", "OUTPUT",
  "OPENPAREN", "CLOSEPAREN", "OPENBRACE", "CLOSEBRACE", "COMMA",
  "SEMICOLON", "ASSIGN", "PLUS", "MINUS", "MULT", "DIV", "MOD", "LESS",
  "LESSEQUAL", "EQUAL", "UNEQUAL", "GREATEREQUAL", "GREATER", "NOT", "OR",
  "AND", "$accept", "S", "statements", "statement", "type", "rvalue",
  "lvalue", "boolexp", "relexp", "arithexp", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const unsigned char
   TestParser ::yyrline_[] =
  {
       0,    73,    73,    81,    86,    95,   100,   105,   110,   115,
     120,   125,   133,   141,   149,   157,   162,   167,   172,   177,
     185,   190,   195,   200,   205,   210,   218,   223,   228,   233,
     238,   243,   248,   253
  };

  void
   TestParser ::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
   TestParser ::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

   TestParser ::symbol_kind_type
   TestParser ::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33
    };
    // Last valid token kind.
    const int code_max = 288;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

} // yy
#line 1285 "parser.cpp"

#line 260 "parser.y"


void yy::TestParser::error(const std::string& msg)
{
    std::cerr << msg << std::endl;
}
